#AFTER_TEST.py
from pverify.drivers.Scope.lcscope import IIviScope
from pverify.drivers.SimplifiedLabInstruments import SimpleScope

scope = SimpleScope(IIviScope())  #definition of oscilloscope object
resourcename = 'USB0::0x05FF::0x1023::2801N55814::INSTR' #ID oscilloscope
scope.Initialize(ResourceName=resourcename, IdQuery=True, Reset=False,
                 OptionString='')

#EACH CHANNEL OF THE OSCILLOSCOPE:
scope.ch1 = scope.GetChannel(1)
scope.ch2 = scope.GetChannel(2)
scope.ch3 = scope.GetChannel(3)
scope.ch4 = scope.GetChannel(4)

##
from pverify.drivers.DCPwr.hpe364xa import IIviDCPwr
from pverify.drivers.SimplifiedLabInstruments import SimpleDCSource
# initialization
PWR_CORE = SimpleDCSource(IIviDCPwr()) #definition of pwr supply(1), Vcore
resourcename_core = 'GPIB0::5::INSTR' #ID of pwr1
PWR_CORE.Initialize(ResourceName=resourcename_core, IdQuery=True, Reset=False,
                    OptionString='simulate=False')
PWR_CORE.chcore = PWR_CORE.GetChannel(1)

PWR_ExtVddp = SimpleDCSource(IIviDCPwr()) #definition of pwr supply(2) (Vext and Vddp)
resourcename_ext_ddp3 = 'GPIB0::4::INSTR' #ID of pwr2
PWR_ExtVddp.Initialize(ResourceName=resourcename_ext_ddp3, IdQuery=True, Reset=False,
                       OptionString='simulate=False')
PWR_ExtVddp.ch1 = PWR_ExtVddp.GetChannel(1)
PWR_ExtVddp.ch2 = PWR_ExtVddp.GetChannel(2)

actualVcore = round(PWR_ExtVddp.ch2.Measure_Voltage(), 1) #only one decimal value after the comma
if actualVcore == 5.0:
   # save waveform at nominal voltage
    dataOfCH1 = scope.ch1.GetProbeWaveform()
    dataOfCH1.save_to_file(r'C:\Users\lavignia\Desktop\results\ICORE_nominal.npz')
  # now, change voltage for next iteration
    PWR_CORE.chcore.Configure_VoltageLevel(Level=1.33, CurrentLimit=1)
    PWR_ExtVddp.ch1.Configure_VoltageLevel(Level=3.63, CurrentLimit=1)
    PWR_ExtVddp.ch2.Configure_VoltageLevel(Level=5.5, CurrentLimit=1)
    PWR_CORE.chcore.Enable(Enabled=True)
    PWR_ExtVddp.ch1.Enable(Enabled=True)
    PWR_ExtVddp.ch2.Enable(Enabled=True)
elif actualVcore == 5.5:
    # save waveform at maximum voltage
    dataOfCH1 = scope.ch1.GetProbeWaveform()
    dataOfCH1.save_to_file(r'C:\Users\lavignia\Desktop\results\ICORE_maximum.npz')
    # now, change voltage for next iteration
    PWR_CORE.chcore.Configure_VoltageLevel(Level=1.14, CurrentLimit=1)
    PWR_ExtVddp.ch1.Configure_VoltageLevel(Level=3, CurrentLimit=1)
    PWR_ExtVddp.ch2.Configure_VoltageLevel(Level=4, CurrentLimit=1)
    PWR_CORE.chcore.Enable(Enabled=True)
    PWR_ExtVddp.ch1.Enable(Enabled=True)
    PWR_ExtVddp.ch2.Enable(Enabled=True)
elif actualVcore ==4.0:
#    save waveform at minimum voltage
    dataOfCH1 = scope.ch1.GetProbeWaveform()
    dataOfCH1.save_to_file(r'C:\Users\lavignia\Desktop\results\ICORE_minimum.npz')
    # now, set the nominal voltage
    PWR_CORE.chcore.Configure_VoltageLevel(Level=1.25, CurrentLimit=1)
    PWR_ExtVddp.ch1.Configure_VoltageLevel(Level=3.3, CurrentLimit=1)
    PWR_ExtVddp.ch2.Configure_VoltageLevel(Level=5, CurrentLimit=1)
    PWR_CORE.chcore.Enable(Enabled=True)
    PWR_ExtVddp.ch1.Enable(Enabled=True)
    PWR_ExtVddp.ch2.Enable(Enabled=True)

# Arm scope waiting for the trigger
scope.Arm(Continuous=True)
